diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/update.php ./wordpress-3.4/wp-includes/update.php
*** ./wordpress-3.3.2/wp-includes/update.php	2011-11-16 01:23:15.000000000 -0600
--- ./wordpress-3.4/wp-includes/update.php	2012-03-24 09:07:12.000000000 -0500
***************
*** 34,39 ****
--- 34,45 ----
  		$current->version_checked = $wp_version;
  	}
  
+ 	// Wait 60 seconds between multiple version check requests
+ 	$timeout = 60;
+ 	$time_not_changed = isset( $current->last_checked ) && $timeout > ( time() - $current->last_checked );
+ 	if ( $time_not_changed )
+ 		return false;
+ 
  	$locale = apply_filters( 'core_version_check_locale', get_locale() );
  
  	// Update last_checked for current to prevent multiple blocking requests if request hangs
***************
*** 85,94 ****
  		return false;
  
  	$body = trim( wp_remote_retrieve_body( $response ) );
! 	if ( ! $body = maybe_unserialize( $body ) )
! 		return false;
! 	if ( ! isset( $body['offers'] ) )
  		return false;
  	$offers = $body['offers'];
  
  	foreach ( $offers as &$offer ) {
--- 91,101 ----
  		return false;
  
  	$body = trim( wp_remote_retrieve_body( $response ) );
! 	$body = maybe_unserialize( $body );
! 
! 	if ( ! is_array( $body ) || ! isset( $body['offers'] ) )
  		return false;
+ 
  	$offers = $body['offers'];
  
  	foreach ( $offers as &$offer ) {
***************
*** 143,172 ****
  
  	$new_option = new stdClass;
  	$new_option->last_checked = time();
- 	// Check for updated every 60 minutes if hitting update pages; else, check every 12 hours.
- 	$timeout = in_array( current_filter(), array( 'load-plugins.php', 'load-update.php', 'load-update-core.php' ) ) ? 3600 : 43200;
- 	$time_not_changed = isset( $current->last_checked ) && $timeout > ( time() - $current->last_checked );
- 
- 	$plugin_changed = false;
- 	foreach ( $plugins as $file => $p ) {
- 		$new_option->checked[ $file ] = $p['Version'];
  
! 		if ( !isset( $current->checked[ $file ] ) || strval($current->checked[ $file ]) !== strval($p['Version']) )
! 			$plugin_changed = true;
  	}
  
! 	if ( isset ( $current->response ) && is_array( $current->response ) ) {
! 		foreach ( $current->response as $plugin_file => $update_details ) {
! 			if ( ! isset($plugins[ $plugin_file ]) ) {
  				$plugin_changed = true;
! 				break;
  			}
  		}
- 	}
  
! 	// Bail if we've checked in the last 12 hours and if nothing has changed
! 	if ( $time_not_changed && !$plugin_changed )
! 		return false;
  
  	// Update last_checked for current to prevent multiple blocking requests if request hangs
  	$current->last_checked = time();
--- 150,193 ----
  
  	$new_option = new stdClass;
  	$new_option->last_checked = time();
  
! 	// Check for update on a different schedule, depending on the page.
! 	switch ( current_filter() ) {
! 		case 'load-update-core.php' :
! 			$timeout = 60; // 1 min
! 			break;
! 		case 'load-plugins.php' :
! 		case 'load-update.php' :
! 			$timeout = 3600; // 1 hour
! 			break;
! 		default :
! 			$timeout = 43200; // 12 hours
  	}
  
! 	$time_not_changed = isset( $current->last_checked ) && $timeout > ( time() - $current->last_checked );
! 
! 	if ( $time_not_changed ) {
! 		$plugin_changed = false;
! 		foreach ( $plugins as $file => $p ) {
! 			$new_option->checked[ $file ] = $p['Version'];
! 
! 			if ( !isset( $current->checked[ $file ] ) || strval($current->checked[ $file ]) !== strval($p['Version']) )
  				$plugin_changed = true;
! 		}
! 
! 		if ( isset ( $current->response ) && is_array( $current->response ) ) {
! 			foreach ( $current->response as $plugin_file => $update_details ) {
! 				if ( ! isset($plugins[ $plugin_file ]) ) {
! 					$plugin_changed = true;
! 					break;
! 				}
  			}
  		}
  
! 		// Bail if we've checked recently and if nothing has changed
! 		if ( ! $plugin_changed )
! 			return false;
! 	}
  
  	// Update last_checked for current to prevent multiple blocking requests if request hangs
  	$current->last_checked = time();
***************
*** 185,193 ****
  	if ( is_wp_error( $raw_response ) || 200 != wp_remote_retrieve_response_code( $raw_response ) )
  		return false;
  
! 	$response = unserialize( wp_remote_retrieve_body( $raw_response ) );
  
! 	if ( false !== $response )
  		$new_option->response = $response;
  	else
  		$new_option->response = array();
--- 206,214 ----
  	if ( is_wp_error( $raw_response ) || 200 != wp_remote_retrieve_response_code( $raw_response ) )
  		return false;
  
! 	$response = maybe_unserialize( wp_remote_retrieve_body( $raw_response ) );
  
! 	if ( is_array( $response ) )
  		$new_option->response = $response;
  	else
  		$new_option->response = array();
***************
*** 214,270 ****
  	if ( defined( 'WP_INSTALLING' ) )
  		return false;
  
! 	if ( !function_exists( 'get_themes' ) )
! 		require_once( ABSPATH . 'wp-includes/theme.php' );
! 
! 	$installed_themes = get_themes( );
  	$last_update = get_site_transient( 'update_themes' );
  	if ( ! is_object($last_update) )
  		$last_update = new stdClass;
  
- 	// Check for updated every 60 minutes if hitting update pages; else, check every 12 hours.
- 	$timeout = in_array( current_filter(), array( 'load-themes.php', 'load-update.php', 'load-update-core.php' ) ) ? 3600 : 43200;
- 	$time_not_changed = isset( $last_update->last_checked ) && $timeout > ( time( ) - $last_update->last_checked );
- 
  	$themes = array();
  	$checked = array();
- 	$exclude_fields = array('Template Files', 'Stylesheet Files', 'Status', 'Theme Root', 'Theme Root URI', 'Template Dir', 'Stylesheet Dir', 'Description', 'Tags', 'Screenshot');
  
  	// Put slug of current theme into request.
  	$themes['current_theme'] = get_option( 'stylesheet' );
  
! 	foreach ( (array) $installed_themes as $theme_title => $theme ) {
! 		$themes[$theme['Stylesheet']] = array();
! 		$checked[$theme['Stylesheet']] = $theme['Version'];
! 
! 		$themes[$theme['Stylesheet']]['Name'] = $theme['Name'];
! 		$themes[$theme['Stylesheet']]['Version'] = $theme['Version'];
! 
! 		foreach ( (array) $theme as $key => $value ) {
! 			if ( !in_array($key, $exclude_fields) )
! 				$themes[$theme['Stylesheet']][$key] = $value;
! 		}
  	}
  
! 	$theme_changed = false;
! 	foreach ( $checked as $slug => $v ) {
! 		$update_request->checked[ $slug ] = $v;
  
! 		if ( !isset( $last_update->checked[ $slug ] ) || strval($last_update->checked[ $slug ]) !== strval($v) )
! 			$theme_changed = true;
! 	}
  
! 	if ( isset ( $last_update->response ) && is_array( $last_update->response ) ) {
! 		foreach ( $last_update->response as $slug => $update_details ) {
! 			if ( ! isset($checked[ $slug ]) ) {
  				$theme_changed = true;
! 				break;
  			}
  		}
- 	}
  
! 	if ( $time_not_changed && !$theme_changed )
! 		return false;
  
  	// Update last_checked for current to prevent multiple blocking requests if request hangs
  	$last_update->last_checked = time();
--- 235,302 ----
  	if ( defined( 'WP_INSTALLING' ) )
  		return false;
  
! 	$installed_themes = wp_get_themes();
  	$last_update = get_site_transient( 'update_themes' );
  	if ( ! is_object($last_update) )
  		$last_update = new stdClass;
  
  	$themes = array();
  	$checked = array();
  
  	// Put slug of current theme into request.
  	$themes['current_theme'] = get_option( 'stylesheet' );
  
! 	foreach ( $installed_themes as $theme ) {
! 		$checked[ $theme->get_stylesheet() ] = $theme->get('Version');
! 
! 		$themes[ $theme->get_stylesheet() ] = array(
! 			'Name'       => $theme->get('Name'),
! 			'Title'      => $theme->get('Name'),
! 			'Version'    => $theme->get('Version'),
! 			'Author'     => $theme->get('Author'),
! 			'Author URI' => $theme->get('AuthorURI'),
! 			'Template'   => $theme->get_template(),
! 			'Stylesheet' => $theme->get_stylesheet(),
! 		);
! 	}
! 
! 	// Check for update on a different schedule, depending on the page.
! 	switch ( current_filter() ) {
! 		case 'load-update-core.php' :
! 			$timeout = 60; // 1 min
! 			break;
! 		case 'load-themes.php' :
! 		case 'load-update.php' :
! 			$timeout = 3600; // 1 hour
! 			break;
! 		default :
! 			$timeout = 43200; // 12 hours
  	}
  
! 	$time_not_changed = isset( $last_update->last_checked ) && $timeout > ( time( ) - $last_update->last_checked );
  
! 	if ( $time_not_changed ) {
! 		$theme_changed = false;
! 		foreach ( $checked as $slug => $v ) {
! 			$update_request->checked[ $slug ] = $v;
  
! 			if ( !isset( $last_update->checked[ $slug ] ) || strval($last_update->checked[ $slug ]) !== strval($v) )
  				$theme_changed = true;
! 		}
! 
! 		if ( isset ( $last_update->response ) && is_array( $last_update->response ) ) {
! 			foreach ( $last_update->response as $slug => $update_details ) {
! 				if ( ! isset($checked[ $slug ]) ) {
! 					$theme_changed = true;
! 					break;
! 				}
  			}
  		}
  
! 		// Bail if we've checked recently and if nothing has changed
! 		if ( ! $theme_changed )
! 			return false;
! 	}
  
  	// Update last_checked for current to prevent multiple blocking requests if request hangs
  	$last_update->last_checked = time();
***************
*** 285,292 ****
  	$new_update->last_checked = time( );
  	$new_update->checked = $checked;
  
! 	$response = unserialize( wp_remote_retrieve_body( $raw_response ) );
! 	if ( false !== $response )
  		$new_update->response = $response;
  
  	set_site_transient( 'update_themes', $new_update );
--- 317,324 ----
  	$new_update->last_checked = time( );
  	$new_update->checked = $checked;
  
! 	$response = maybe_unserialize( wp_remote_retrieve_body( $raw_response ) );
! 	if ( is_array( $response ) )
  		$new_update->response = $response;
  
  	set_site_transient( 'update_themes', $new_update );
***************
*** 397,403 ****
  		wp_schedule_event(time(), 'twicedaily', 'wp_update_themes');
  }
  
! if ( ! is_main_site() && ! is_network_admin() )
  	return;
  
  add_action( 'admin_init', '_maybe_update_core' );
--- 429,435 ----
  		wp_schedule_event(time(), 'twicedaily', 'wp_update_themes');
  }
  
! if ( ( ! is_main_site() && ! is_network_admin() ) || ( defined( 'DOING_AJAX' ) && DOING_AJAX ) )
  	return;
  
  add_action( 'admin_init', '_maybe_update_core' );
***************
*** 416,420 ****
  add_action( 'wp_update_themes', 'wp_update_themes' );
  
  add_action('init', 'wp_schedule_update_checks');
- 
- ?>
--- 448,450 ----
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/user.php ./wordpress-3.4/wp-includes/user.php
*** ./wordpress-3.3.2/wp-includes/user.php	2012-03-02 15:02:22.000000000 -0600
--- ./wordpress-3.4/wp-includes/user.php	2012-04-27 10:57:51.000000000 -0500
***************
*** 154,160 ****
  function count_user_posts($userid) {
  	global $wpdb;
  
! 	$where = get_posts_by_author_sql('post', TRUE, $userid);
  
  	$count = $wpdb->get_var( "SELECT COUNT(*) FROM $wpdb->posts $where" );
  
--- 153,159 ----
  function count_user_posts($userid) {
  	global $wpdb;
  
! 	$where = get_posts_by_author_sql('post', true, $userid);
  
  	$count = $wpdb->get_var( "SELECT COUNT(*) FROM $wpdb->posts $where" );
  
***************
*** 165,175 ****
   * Number of posts written by a list of users.
   *
   * @since 3.0.0
!  * @param array $user_ids Array of user IDs.
   * @param string|array $post_type Optional. Post type to check. Defaults to post.
   * @return array Amount of posts each user has written.
   */
! function count_many_users_posts($users, $post_type = 'post' ) {
  	global $wpdb;
  
  	$count = array();
--- 164,175 ----
   * Number of posts written by a list of users.
   *
   * @since 3.0.0
!  *
!  * @param array $users Array of user IDs.
   * @param string|array $post_type Optional. Post type to check. Defaults to post.
   * @return array Amount of posts each user has written.
   */
! function count_many_users_posts( $users, $post_type = 'post' ) {
  	global $wpdb;
  
  	$count = array();
***************
*** 259,265 ****
  	else
  		$user = new WP_User( $user );
  
! 	if ( ! isset( $user->ID ) )
  		return false;
  
  	if ( $user->has_prop( $wpdb->prefix . $option ) ) // Blog specific
--- 259,265 ----
  	else
  		$user = new WP_User( $user );
  
! 	if ( ! $user->exists() )
  		return false;
  
  	if ( $user->has_prop( $wpdb->prefix . $option ) ) // Blog specific
***************
*** 379,384 ****
--- 378,384 ----
  				'include' => array(),
  				'exclude' => array(),
  				'search' => '',
+ 				'search_columns' => array(),
  				'orderby' => 'login',
  				'order' => 'ASC',
  				'offset' => '',
***************
*** 477,490 ****
  			if ( $wild )
  				$search = trim($search, '*');
  
! 			if ( false !== strpos( $search, '@') )
! 				$search_columns = array('user_email');
! 			elseif ( is_numeric($search) )
! 				$search_columns = array('user_login', 'ID');
! 			elseif ( preg_match('|^https?://|', $search) )
! 				$search_columns = array('user_url');
! 			else
! 				$search_columns = array('user_login', 'user_nicename');
  
  			$this->query_where .= $this->get_search_sql( $search, $search_columns, $wild );
  		}
--- 477,495 ----
  			if ( $wild )
  				$search = trim($search, '*');
  
! 			$search_columns = array();
! 			if ( $qv['search_columns'] )
! 				$search_columns = array_intersect( $qv['search_columns'], array( 'ID', 'user_login', 'user_email', 'user_url', 'user_nicename' ) );
! 			if ( ! $search_columns ) {
! 				if ( false !== strpos( $search, '@') )
! 					$search_columns = array('user_email');
! 				elseif ( is_numeric($search) )
! 					$search_columns = array('user_login', 'ID');
! 				elseif ( preg_match('|^https?://|', $search) && ! wp_is_large_network( 'users' ) )
! 					$search_columns = array('user_url');
! 				else
! 					$search_columns = array('user_login', 'user_nicename');
! 			}
  
  			$this->query_where .= $this->get_search_sql( $search, $search_columns, $wild );
  		}
***************
*** 647,653 ****
   *
   * @param int $user_id User ID
   * @param bool $all Whether to retrieve all blogs, or only blogs that are not marked as deleted, archived, or spam.
!  * @return array A list of the user's blogs. False if the user was not found or an empty array if the user has no blogs.
   */
  function get_blogs_of_user( $user_id, $all = false ) {
  	global $wpdb;
--- 652,658 ----
   *
   * @param int $user_id User ID
   * @param bool $all Whether to retrieve all blogs, or only blogs that are not marked as deleted, archived, or spam.
!  * @return array A list of the user's blogs. An empty array if the user doesn't exist or belongs to no blogs.
   */
  function get_blogs_of_user( $user_id, $all = false ) {
  	global $wpdb;
***************
*** 656,666 ****
  
  	// Logged out users can't have blogs
  	if ( empty( $user_id ) )
! 		return false;
  
  	$keys = get_user_meta( $user_id );
  	if ( empty( $keys ) )
! 		return false;
  
  	if ( ! is_multisite() ) {
  		$blog_id = get_current_blog_id();
--- 661,671 ----
  
  	// Logged out users can't have blogs
  	if ( empty( $user_id ) )
! 		return array();
  
  	$keys = get_user_meta( $user_id );
  	if ( empty( $keys ) )
! 		return array();
  
  	if ( ! is_multisite() ) {
  		$blog_id = get_current_blog_id();
***************
*** 725,732 ****
   * @since MU 1.1
   * @uses get_blogs_of_user()
   *
!  * @param int $user_id The unique ID of the user
!  * @param int $blog Optional. If no blog_id is provided, current site is used
   * @return bool
   */
  function is_user_member_of_blog( $user_id = 0, $blog_id = 0 ) {
--- 730,737 ----
   * @since MU 1.1
   * @uses get_blogs_of_user()
   *
!  * @param int $user_id Optional. The unique ID of the user. Defaults to the current user.
!  * @param int $blog_id Optional. ID of the blog to check. Defaults to the current site.
   * @return bool
   */
  function is_user_member_of_blog( $user_id = 0, $blog_id = 0 ) {
***************
*** 740,749 ****
  		$blog_id = get_current_blog_id();
  
  	$blogs = get_blogs_of_user( $user_id );
! 	if ( is_array( $blogs ) )
! 		return array_key_exists( $blog_id, $blogs );
! 	else
! 		return false;
  }
  
  /**
--- 745,751 ----
  		$blog_id = get_current_blog_id();
  
  	$blogs = get_blogs_of_user( $user_id );
! 	return array_key_exists( $blog_id, $blogs );
  }
  
  /**
***************
*** 793,799 ****
   * @link http://codex.wordpress.org/Function_Reference/get_user_meta
   *
   * @param int $user_id Post ID.
!  * @param string $key The meta key to retrieve.
   * @param bool $single Whether to return a single value.
   * @return mixed Will be an array if $single is false. Will be value of meta data field if $single
   *  is true.
--- 795,801 ----
   * @link http://codex.wordpress.org/Function_Reference/get_user_meta
   *
   * @param int $user_id Post ID.
!  * @param string $key Optional. The meta key to retrieve. By default, returns data for all keys.
   * @param bool $single Whether to return a single value.
   * @return mixed Will be an array if $single is false. Will be value of meta data field if $single
   *  is true.
***************
*** 828,834 ****
   * Count number of users who have each of the user roles.
   *
   * Assumes there are neither duplicated nor orphaned capabilities meta_values.
!  * Assumes role names are unique phrases.  Same assumption made by WP_User_Query::prepare_query()
   * Using $strategy = 'time' this is CPU-intensive and should handle around 10^7 users.
   * Using $strategy = 'memory' this is memory-intensive and should handle around 10^5 users, but see WP Bug #12257.
   *
--- 830,836 ----
   * Count number of users who have each of the user roles.
   *
   * Assumes there are neither duplicated nor orphaned capabilities meta_values.
!  * Assumes role names are unique phrases. Same assumption made by WP_User_Query::prepare_query()
   * Using $strategy = 'time' this is CPU-intensive and should handle around 10^7 users.
   * Using $strategy = 'memory' this is memory-intensive and should handle around 10^5 users, but see WP Bug #12257.
   *
***************
*** 855,861 ****
  		// Build a CPU-intensive query that will return concise information.
  		$select_count = array();
  		foreach ( $avail_roles as $this_role => $name ) {
! 			$select_count[] = "COUNT(NULLIF(`meta_value` LIKE '%" . like_escape($this_role) . "%', FALSE))";
  		}
  		$select_count = implode(', ', $select_count);
  
--- 857,863 ----
  		// Build a CPU-intensive query that will return concise information.
  		$select_count = array();
  		foreach ( $avail_roles as $this_role => $name ) {
! 			$select_count[] = "COUNT(NULLIF(`meta_value` LIKE '%\"" . like_escape( $this_role ) . "\"%', false))";
  		}
  		$select_count = implode(', ', $select_count);
  
***************
*** 883,896 ****
  		$users_of_blog = $wpdb->get_col( "SELECT meta_value FROM $wpdb->usermeta WHERE meta_key = '{$blog_prefix}capabilities'" );
  
  		foreach ( $users_of_blog as $caps_meta ) {
! 			$b_roles = unserialize($caps_meta);
! 			if ( is_array($b_roles) ) {
! 				foreach ( $b_roles as $b_role => $val ) {
! 					if ( isset($avail_roles[$b_role]) ) {
! 						$avail_roles[$b_role]++;
! 					} else {
! 						$avail_roles[$b_role] = 1;
! 					}
  				}
  			}
  		}
--- 885,898 ----
  		$users_of_blog = $wpdb->get_col( "SELECT meta_value FROM $wpdb->usermeta WHERE meta_key = '{$blog_prefix}capabilities'" );
  
  		foreach ( $users_of_blog as $caps_meta ) {
! 			$b_roles = maybe_unserialize($caps_meta);
! 			if ( ! is_array( $b_roles ) )
! 				continue;
! 			foreach ( $b_roles as $b_role => $val ) {
! 				if ( isset($avail_roles[$b_role]) ) {
! 					$avail_roles[$b_role]++;
! 				} else {
! 					$avail_roles[$b_role] = 1;
  				}
  			}
  		}
***************
*** 935,951 ****
  	$user_ID    = (int) $user->ID;
  	$user_level = (int) isset($user->user_level) ? $user->user_level : 0;
  
! 	if ( 0 == $user->ID ) {
  		$user_login = $user_email = $user_url = $user_pass_md5 = $user_identity = '';
  		return;
  	}
  
! 	$userdata	= $user;
! 	$user_login	= $user->user_login;
! 	$user_email	= $user->user_email;
! 	$user_url	= $user->user_url;
! 	$user_pass_md5	= md5($user->user_pass);
! 	$user_identity	= $user->display_name;
  }
  
  /**
--- 937,953 ----
  	$user_ID    = (int) $user->ID;
  	$user_level = (int) isset($user->user_level) ? $user->user_level : 0;
  
! 	if ( ! $user->exists() ) {
  		$user_login = $user_email = $user_url = $user_pass_md5 = $user_identity = '';
  		return;
  	}
  
! 	$userdata   = $user;
! 	$user_login = $user->user_login;
! 	$user_email = $user->user_email;
! 	$user_url   = $user->user_url;
! 	$user_pass_md5 = md5( $user->user_pass );
! 	$user_identity = $user->display_name;
  }
  
  /**
***************
*** 974,980 ****
   * <li>id - Default is the value of the 'name' parameter. ID attribute of select element.</li>
   * <li>class - Class attribute of select element.</li>
   * <li>blog_id - ID of blog (Multisite only). Defaults to ID of current blog.</li>
!  * <li>who - Which users to query.  Currently only 'authors' is supported. Default is all users.</li>
   * </ol>
   *
   * @since 2.3.0
--- 976,982 ----
   * <li>id - Default is the value of the 'name' parameter. ID attribute of select element.</li>
   * <li>class - Class attribute of select element.</li>
   * <li>blog_id - ID of blog (Multisite only). Defaults to ID of current blog.</li>
!  * <li>who - Which users to query. Currently only 'authors' is supported. Default is all users.</li>
   * </ol>
   *
   * @since 2.3.0
***************
*** 1056,1072 ****
   * when calling filters.
   *
   * @since 2.3.0
!  * @uses apply_filters() Calls 'edit_$field' and '{$field_no_prefix}_edit_pre' passing $value and
!  *  $user_id if $context == 'edit' and field name prefix == 'user_'.
!  *
!  * @uses apply_filters() Calls 'edit_user_$field' passing $value and $user_id if $context == 'db'.
!  * @uses apply_filters() Calls 'pre_$field' passing $value if $context == 'db' and field name prefix == 'user_'.
!  * @uses apply_filters() Calls '{$field}_pre' passing $value if $context == 'db' and field name prefix != 'user_'.
!  *
   * @uses apply_filters() Calls '$field' passing $value, $user_id and $context if $context == anything
!  *  other than 'raw', 'edit' and 'db' and field name prefix == 'user_'.
!  * @uses apply_filters() Calls 'user_$field' passing $value if $context == anything other than 'raw',
!  *  'edit' and 'db' and field name prefix != 'user_'.
   *
   * @param string $field The user Object field name.
   * @param mixed $value The user Object value.
--- 1058,1069 ----
   * when calling filters.
   *
   * @since 2.3.0
!  * @uses apply_filters() Calls 'edit_$field' passing $value and $user_id if $context == 'edit'.
!  *  $field is prefixed with 'user_' if it isn't already.
!  * @uses apply_filters() Calls 'pre_$field' passing $value if $context == 'db'. $field is prefixed with
!  *  'user_' if it isn't already.
   * @uses apply_filters() Calls '$field' passing $value, $user_id and $context if $context == anything
!  *  other than 'raw', 'edit' and 'db'. $field is prefixed with 'user_' if it isn't already.
   *
   * @param string $field The user Object field name.
   * @param mixed $value The user Object value.
***************
*** 1086,1096 ****
  	if ( !is_string($value) && !is_numeric($value) )
  		return $value;
  
! 	$prefixed = false;
! 	if ( false !== strpos($field, 'user_') ) {
! 		$prefixed = true;
! 		$field_no_prefix = str_replace('user_', '', $field);
! 	}
  
  	if ( 'edit' == $context ) {
  		if ( $prefixed ) {
--- 1083,1089 ----
  	if ( !is_string($value) && !is_numeric($value) )
  		return $value;
  
! 	$prefixed = false !== strpos( $field, 'user_' );
  
  	if ( 'edit' == $context ) {
  		if ( $prefixed ) {
***************
*** 1147,1161 ****
   *
   * @since 3.0.0
   *
!  * @param int $id User ID
   */
! function clean_user_cache($id) {
! 	$user = WP_User::get_data_by( 'id', $id );
  
! 	wp_cache_delete($id, 'users');
! 	wp_cache_delete($user->user_login, 'userlogins');
! 	wp_cache_delete($user->user_email, 'useremail');
! 	wp_cache_delete($user->user_nicename, 'userslugs');
  }
  
  /**
--- 1140,1158 ----
   *
   * @since 3.0.0
   *
!  * @param WP_User|int $user User object or ID to be cleaned from the cache
   */
! function clean_user_cache( $user ) {
! 	if ( is_numeric( $user ) )
! 		$user = new WP_User( $user );
  
! 	if ( ! $user->exists() )
! 		return;
! 
! 	wp_cache_delete( $user->ID, 'users' );
! 	wp_cache_delete( $user->user_login, 'userlogins' );
! 	wp_cache_delete( $user->user_email, 'useremail' );
! 	wp_cache_delete( $user->user_nicename, 'userslugs' );
  }
  
  /**
***************
*** 1493,1497 ****
  	);
  	return apply_filters( 'user_contactmethods', $user_contactmethods, $user );
  }
- 
- ?>
--- 1489,1491 ----
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/vars.php ./wordpress-3.4/wp-includes/vars.php
*** ./wordpress-3.3.2/wp-includes/vars.php	2011-10-18 14:44:00.000000000 -0500
--- ./wordpress-3.4/wp-includes/vars.php	2012-06-04 11:04:54.000000000 -0500
***************
*** 98,101 ****
   */
  $is_iis7 = $is_IIS && (strpos($_SERVER['SERVER_SOFTWARE'], 'Microsoft-IIS/7.') !== false);
  
! ?>
--- 98,126 ----
   */
  $is_iis7 = $is_IIS && (strpos($_SERVER['SERVER_SOFTWARE'], 'Microsoft-IIS/7.') !== false);
  
! /**
!  * Test if the current browser runs on a mobile device (smart phone, tablet, etc.)
!  *
!  * @return bool true|false
!  */
! function wp_is_mobile() {
! 	static $is_mobile;
! 
! 	if ( isset($is_mobile) )
! 		return $is_mobile;
! 
! 	if ( empty($_SERVER['HTTP_USER_AGENT']) ) {
! 		$is_mobile = false;
! 	} elseif ( strpos($_SERVER['HTTP_USER_AGENT'], 'Mobile') !== false // many mobile devices (all iPhone, iPad, etc.)
! 		|| strpos($_SERVER['HTTP_USER_AGENT'], 'Android') !== false
! 		|| strpos($_SERVER['HTTP_USER_AGENT'], 'Silk/') !== false
! 		|| strpos($_SERVER['HTTP_USER_AGENT'], 'Kindle') !== false
! 		|| strpos($_SERVER['HTTP_USER_AGENT'], 'BlackBerry') !== false
! 		|| strpos($_SERVER['HTTP_USER_AGENT'], 'Opera Mini') !== false ) {
! 			$is_mobile = true;
! 	} else {
! 		$is_mobile = false;
! 	}
! 
! 	return $is_mobile;
! }
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/version.php ./wordpress-3.4/wp-includes/version.php
*** ./wordpress-3.3.2/wp-includes/version.php	2012-04-20 09:49:49.000000000 -0500
--- ./wordpress-3.4/wp-includes/version.php	2012-06-13 13:08:29.000000000 -0500
***************
*** 4,24 ****
   *
   * @global string $wp_version
   */
! $wp_version = '3.3.2';
  
  /**
   * Holds the WordPress DB revision, increments when changes are made to the WordPress DB schema.
   *
   * @global int $wp_db_version
   */
! $wp_db_version = 19470;
  
  /**
   * Holds the TinyMCE version
   *
   * @global string $tinymce_version
   */
! $tinymce_version = '345-20111127';
  
  /**
   * Holds the cache manifest version
--- 4,24 ----
   *
   * @global string $wp_version
   */
! $wp_version = '3.4';
  
  /**
   * Holds the WordPress DB revision, increments when changes are made to the WordPress DB schema.
   *
   * @global int $wp_db_version
   */
! $wp_db_version = 20596;
  
  /**
   * Holds the TinyMCE version
   *
   * @global string $tinymce_version
   */
! $tinymce_version = '349-20805';
  
  /**
   * Holds the cache manifest version
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/widgets.php ./wordpress-3.4/wp-includes/widgets.php
*** ./wordpress-3.3.2/wp-includes/widgets.php	2011-11-26 00:16:43.000000000 -0600
--- ./wordpress-3.4/wp-includes/widgets.php	2012-01-05 14:10:39.000000000 -0600
***************
*** 1149,1155 ****
   * Handle sidebars config after theme change
   *
   * @access private
!  * @since 3.3
   */
  function _wp_sidebars_changed() {
  	global $sidebars_widgets;
--- 1148,1154 ----
   * Handle sidebars config after theme change
   *
   * @access private
!  * @since 3.3.0
   */
  function _wp_sidebars_changed() {
  	global $sidebars_widgets;
